package org.elsysbg.objectDetectionTools;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;


/**
 * This class helps to open the image we want
 * @author julls
 *
 */
public class Basic {
	protected String baseDirectory;
	protected int index;
	protected BufferedImage bufIn;
	protected BufferedImage bufOut;
	
	public Basic(String baseDirectory, int indexOfFile) {
		this.baseDirectory = baseDirectory;
		this.index = indexOfFile;
	}

	protected void openInOutFile(String dir, String file ,String type ) throws IOException{
		String path= "";
		if (dir.equals("outbox")){
			path = baseDirectory + "\\" +dir + "\\plate" + index + "\\plate" +file + Convert.convertToString(index) + "." + type;
		}
		else {
			path = baseDirectory + "\\" + dir + "\\plate" + file + Convert.convertToString(index) + "." + type;
		}
		bufIn = ImageIO.read(new File(path));
		bufOut = new BufferedImage(bufIn.getWidth(),bufIn.getHeight(),BufferedImage.TYPE_INT_RGB);
		
	}
	
	protected void openInOutFile(String dir, String file, String type, int width, int height) throws IOException{
		String path= "";
		if (dir.equals("outbox")){
			path = baseDirectory + "\\" +dir + "\\plate" + index + "\\plate" +file + Convert.convertToString(index) + "." + type;
		}
		else {
			path = baseDirectory + "\\" + dir + "\\plate" + file + Convert.convertToString(index) + "." + type;
		}
		System.out.println(path);
		bufIn = ImageIO.read(new File(path));
		bufOut = new BufferedImage(width,height,BufferedImage.TYPE_INT_RGB);
	}

	protected void saveOutFile(String dir, String fileName , String type) throws IOException{
		new File(baseDirectory+"\\" + dir + "\\plate" + index).mkdir();
		ImageIO.write(bufOut, type, new File(baseDirectory + "\\" + dir + "\\plate"
				+ index + "\\plate" + fileName + Convert.convertToString(index) + "." + type));
	}
	
	protected void closeInFile(){
		bufIn = null;
	}

}
